unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, PaxProgram, PaxCompiler, StdCtrls, PaxRegister, PaxBasicLanguage;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    PaxCompiler1: TPaxCompiler;
    PaxProgram1: TPaxProgram;
    Button3: TButton;
    Memo2: TMemo;
    PaxProgram2: TPaxProgram;
    PaxBasicLanguage1: TPaxBasicLanguage;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  H_TButton, H_TForm1: Integer;

procedure TForm1.Button1Click(Sender: TObject);
var
  I: Integer;
begin
  if Assigned(Button2.OnClick) then
  begin
    ShowMessage('The event handler has been already created.');
    Exit;
  end;

  PaxCompiler1.Reset;
  PaxCompiler1.RegisterLanguage(PaxBasicLanguage1);
  PaxCompiler1.AddModule('1', 'Basic');
  PaxCompiler1.AddCode('1', Memo1.Lines.Text);
  PaxCompiler1.RegisterVariable(0, 'Button2', H_TButton, @Button2);
  PaxCompiler1.RegisterVariable(0, 'Form1', H_TForm1, @Form1);

  if PaxCompiler1.Compile(PaxProgram1) then
  begin
    PaxProgram1.Run;
    ShowMessage('The event handler has been created. Click Button2.');
  end
  else
    for I:=0 to PaxCompiler1.ErrorCount - 1 do
      ShowMessage(PaxCompiler1.ErrorMessage[I]);
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  I: Integer;
begin
  PaxCompiler1.Reset;
  PaxCompiler1.RegisterLanguage(PaxBasicLanguage1);
  PaxCompiler1.AddModule('1', 'Basic');
  PaxCompiler1.AddCode('1', Memo2.Lines.Text);
  PaxCompiler1.RegisterVariable(0, 'Button2', H_TButton, @Button2);

  if PaxCompiler1.Compile(PaxProgram2) then
  begin
    PaxProgram2.Run;
    ShowMessage('The event handler has been removed.');
  end
  else
    for I:=0 to PaxCompiler1.ErrorCount - 1 do
      ShowMessage(PaxCompiler1.ErrorMessage[I]);
end;

initialization

  H_TButton := RegisterClassType(0, TButton);
  H_TForm1 := RegisterClassType(0, TForm1);
  RegisterHeader(0, 'procedure ShowMessage(const Msg: string);', @ShowMessage);

end.
